

function Blatt2 
close all % close all figures
dbstop if error  % sobald ein Fehler im code ist, erhält man an der Stelle Zugriff auf den workspace (siehe "keyboard")

% Werte aus der Aufgabe
T=500;
h=.005;
S0=8*10^7;
I0=5*10^4;
R0=10^5;
y0=[S0 I0 R0];
gamma=log(0.1)/(-14);

c=1.1*gamma/(S0+I0+R0);
%c=0.000000004;
% berechne Lösung
[y1,y2,y3]=SIR(T,h,y0,c,gamma);

% time interval (for plots)
t = 0:h:T;
figure(1)
plot(t, y1,'b',t,y2,'r-',t,y3,'g--')
legend('potentiell ansteckbar','infektioes','immun/verstorben','Location','Best'); % Legende im plot
title(' Zeitliche Entwicklung fuer niedrige Ansteckungsrate')
xlabel('Zeit t')
ylabel('Populationen')

%c=0.000000001;
c=3*gamma/(S0+I0+R0);
% berechne Lösung
[y1,y2,y3]=SIR(T,h,y0,c,gamma);

% time interval (for plots)
t = 0:h:T;
figure(2)
plot(t, y1,'b',t,y2,'r-',t,y3,'g--')
legend('potentiell ansteckbar','infektioes','immun/verstorben','Location','Best'); % Legende im plot
title(' Zeitliche Entwicklung fuer hohe Ansteckungsrate')
xlabel('Zeit t')
ylabel('Populationen')

end

function [y1,y2,y3] = SIR(T,h,y0,c,gamma)
% Explizites Euler-Verfahren 
%
% T: Endzeitpunkt
% h: Zeitschrittweite
% y0: Startwerte der Populationen
% r,f: Wachstumsraten
% y1,y2: Anzahl der jeweiligen Individuen (y1 -> Beute, y2 -> Räuber)

% Deklarierung/Initialisierung:
N = T/h; % Wir nehmen an, dass T und h konsistent zueinander gewählt sind
y1 = zeros(N+1,1); % Bei N Teilintervallen gibt es N+1 Punkte
y2 = zeros(N+1,1);
y3 = zeros(N+1,1);
% Anfangswerte
y1(1) = y0(1);
y2(1) = y0(2);
y3(1) = y0(3);

% Verfahren mit Vorwärtsdifferenzenquotienten und äquidistanter Schrittweite
for j=1:N
    y1(j+1)=y1(j)+h*(-c*y1(j)*y2(j));
    y2(j+1)=y2(j)+h*(c*y1(j)*y2(j)-gamma*y2(j));
    y3(j+1)=y3(j)+h*gamma*y2(j);
end

end